unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComObj, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    ColorDialog1: TColorDialog;
    Button7: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    Label2: TLabel;
    ComboBox4: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox9: TComboBox;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    procedure Slide1(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;
const
//  
  ppBackground = $00000001;
  ppForeground = $00000002;
  ppShadow     = $00000003;
  ppTitle      = $00000004;
  ppFill       = $00000005;
  ppAccent1    = $00000006;
  ppAccent2    = $00000007;
  ppAccent3    = $00000008;
// 
  ppDefaultStyle = $00000001;	//  
  ppTitleStyle   = $00000002;	//  
  ppBodyStyle    = $00000003;	//  

var
  Form1: TForm1;

implementation
var
  W:Variant;
  A: Array[1..2,1..2,1..5] Of Integer =  //  
  ( ((1, 5, 0, 1, $00000F04),
    (1, 5, 0, 1, $00000F04)),
    ((1, 5, 0, 1, $00000F04),
    (1, 5, 0, 1, $00000F04))
   );
  B: Array [1..50] of integer = //  
  (
 $00000F04, $00000301, $00000302, $00000C02, $00000C01,
 $00000401, $00000402, $00000F05, $00000F07, $00000F08,
 $00000504, $00000501, $00000507, $00000505, $00000503,
 $00000508, $00000506, $00000502, $00000D10, $00000D0F,
 $00000D0E, $00000101, $00000F06, $00000601, $00000701,
 $00000F01, $00000F02, $00000F03, $00000D04, $00000D07,
 $00000D01, $00000D03, $00000D02, $00000F0A, $00000000,
 $00000D0A, $00000F0B, $00000F0C, $00000201, $00000D1D,
 $00000E02, $00000E01, $00000E04, $00000D17, $00000A03,
 $00000D1C, $00000804, $00000F10, $00000B04, $00000D15
  );
{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  W:=CreateOleObject('PowerPoint.Application');
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  W.Visible:=CheckBox1.Checked;
end;

procedure TForm1.Button3Click(Sender: TObject);
const
  msoShapeLineCallout2 = 110; // 
var
 V: Variant;
begin
 W.Presentations.Add;
 W.ActivePresentation.Slides.Add(1,1); //  - ppLayoutTitle
 Slide1(Self); //  1- 
 //  
 W.ActivePresentation.Slides.Item(1).Shapes
   .AddShape(msoShapeLineCallout2, 292, 77.25, $72, 48);
 V:=W.ActivePresentation.Slides.Item(1).Shapes.Item(3)
   .TextFrame.TextRange;
 V.Characters(Start:=1,Length:=0).Text:='';
end;

procedure TForm1.Slide1(Sender: TObject);
//  1- 
var
 V,V1: Variant;
begin
 V:=W.ActivePresentation.Slides.Item(1).Shapes.Item(1)
   .TextFrame.TextRange;
 V.Characters(Start:=1,Length:=0).Text:='';
 V.Font.Name := 'Times New Roman';
 V.Font.Size := 44;
 V.Font.Bold := 0;  // msoFalse
 V.Font.Italic := 0; // msoFalse
 V.Font.Underline := 0; // msoFalse
 V.Font.Shadow := 0; // msoFalse
 V.Font.Emboss := 0; // msoFalse
 V.Font.BaseLineOffset := 0;
 V.Font.AutoRotateNumbers := 0; // msoFalse
 V.Font.Color.SchemeColor := 4; // ppTitle

 V1:=W.ActivePresentation.Slides.Item(1).Shapes.Item(2)
   .TextFrame.TextRange;
 V1.Characters(Start:=1,Length:=0).Text:='-' + Chr(13)
    + '  "  "';
 V1.Font.Name := 'Times New Roman';
 V1.Font.Size := 32;
 V1.Font.Bold := 0; // msoFalse
 V1.Font.Italic := 0; // msoFalse
 V1.Font.Underline := 0; // msoFalse
 V1.Font.Shadow := 0; // msoFalse
 V1.Font.Emboss := 0; // msoFalse
 V1.Font.BaseLineOffset := 0;
 V1.Font.AutoRotateNumbers := 0; // msoFalse
 V1.Font.Color.SchemeColor := 2; // ppForeground
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
 W.Quit;
 Close;
end;


procedure TForm1.Button7Click(Sender: TObject);
//  
var
  R,G,B: Byte; //  
  N: Integer;  //  
  L: Integer;  //  
begin
   if ColorDialog1.Execute then
   begin
    R:= ColorDialog1.Color and $FF;
    G:= (ColorDialog1.Color and $FF00) shr 8;
    B:= (ColorDialog1.Color and $FF0000) shr 16;
    N:= ComboBox1.ItemIndex+1;
    L:= ComboBox3.ItemIndex+1;
    W.ActivePresentation.Slides.Item(N).ColorScheme
       .Colors(L).RGB:=RGB(R,G,B);
   end;
end;

procedure TForm1.Button5Click(Sender: TObject);
//   
var
  V: Variant;
begin
  V:=W.ActivePresentation.Slides.Item(1).Shapes.Item(3).Callout;
  if ComboBox5.ItemIndex=0 then V.Accent := False
  else V.Accent := True;
  if ComboBox6.ItemIndex=5 then V.Angle:=-2
  else V.Angle := ComboBox6.ItemIndex+1;
  if ComboBox7.ItemIndex=0 then V.Border := False
  else V.Border := True;
  if ComboBox9.ItemIndex=4 then V.Type:=-2
  else V.Type := ComboBox9.ItemIndex+1;
end;

end.
